#!/usr/bin/env python
# -*- coding: UTF-8 -*-
"""
@Project ：trinity_client
@File    ：upload_image.py
@Author  ：周成融
@Date    ：2023/8/28 13:49:20
@detail  ：
"""
import io
import logging

import cv2

from app.core.config import *
from app.service.utils.new_oss_client import oss_upload_image


# @RunTime
def upload_png_mask(minio_client, front_image, object_name, mask=None):
    try:
        mask_url = None
        if mask is not None:
            mask_inverted = cv2.bitwise_not(mask)
            # 将掩模的3通道转换为4通道，白色部分不透明，黑色部分透明
            rgba_image = cv2.cvtColor(mask_inverted, cv2.COLOR_BGR2BGRA)
            rgba_image[rgba_image[:, :, 0] == 0] = [0, 0, 0, 0]
            req = oss_upload_image(oss_client=minio_client, bucket=AIDA_CLOTHING, object_name=f"mask/mask_{object_name}.png", image_bytes=cv2.imencode('.png', rgba_image)[1])
            mask_url = f"{AIDA_CLOTHING}/mask/mask_{object_name}.png"

        image_data = io.BytesIO()
        front_image.save(image_data, format='PNG')
        image_data.seek(0)
        image_bytes = image_data.read()
        req = oss_upload_image(oss_client=minio_client, bucket=AIDA_CLOTHING, object_name=f"image/image_{object_name}.png", image_bytes=image_bytes)
        image_url = f"{AIDA_CLOTHING}/image/image_{object_name}.png"
        return front_image, image_url, mask_url
    except Exception as e:
        logging.warning(f"upload_png_mask runtime exception : {e}")
